﻿
init python:
    import math
    class radial_menu_item:
        def __init__(self, name, action, icon):
            self.name = name
            self.action = action
            self.icon = icon

    class radial_menu_class:
        def __init__(self, items):
            self.items = items
            self.positions = []
            self.pos_calculator()
        def add(self, item):
            renpy.play("radial/add.ogg", "sound")
            self.items.append(item)
            self.pos_calculator()
        def remove(self, item):
            try:
                self.items.remove(item)
                self.pos_calculator()
                renpy.play("radial/remove.ogg", "sound")
            except:
                pass
        def pos_calculator(self):
            p = len(self.items)
            angle = 2 * 3.14159 / p
            radius = 200
            result = []
            for i in range(p):
                x = radius * math.cos(angle*i)
                y = radius * math.sin(angle*i)
                result.append((x, y, angle*i))
            self.positions = result
    def some_notification(t):
        renpy.notify(t)



# define some menu items
default quick_back = radial_menu_item(
    _("Auto"),
    Preference("auto-forward", "toggle"),
    "radial/1.webp",
    )
default quick_auto = radial_menu_item(
    _("Settings"),
    ShowMenu('preferences'),
    "radial/2.webp",
    )
default quick_settings = radial_menu_item(
    _("Pay"),
    Function(some_notification, "Paid some money."),
    "radial/3.webp",
    )

default radial_apple = radial_menu_item(
    _("Throw"),
    Function(some_notification, "Throw an apple, it missed."),
    "radial/6.webp",
    )
default radial_beer = radial_menu_item(
    _("Beer"),
    Function(some_notification, "Drank a beer."),
    "radial/4.webp",
    )
default radial_burger = radial_menu_item(
    _("Eat"),
    Function(some_notification, "Ate a burger."),
    "radial/5.webp",
    )
default radial_oil = radial_menu_item(
    _("Use"),
    Function(some_notification, "Used oil."),
    "radial/7.webp",
    )
default radial_strawberry = radial_menu_item(
    _("Eat"),
    Function(some_notification, "This strawberry is tasty."),
    "radial/8.webp",
    )
# Define a menu and add those items to it
default radial_menu = radial_menu_class(
    [
        quick_back,
        quick_auto,
        quick_settings,
    ]
    )



screen radial_menu_screen(m = radial_menu):
    default alp = 0
    if alp:
        key "r" action ToggleScreenVariable("alp", 1, 0) activate_sound "radial/close.ogg"
    else:
        key "r" action ToggleScreenVariable("alp", 1, 0) activate_sound "radial/open.ogg"
    for p,i in zip(m.positions, m.items):
        button:
            at radial_menu_trans(p[0]*alp, p[1]*alp, 1*alp)
            background None align .5,.5
            activate_sound "radial/clicked.ogg"
            fixed:
                fit_first True
                add i.icon
                text i.name size 20 outlines [(2, "#000", 0, 0)] align .5,.5
            if alp:
                action SetScreenVariable("alp", 0), i.action

    drag:
        frame:
            vbox:
                spacing 8
                text "tests"
                hbox:
                    spacing 8
                    button:
                        xysize 40,40 background "#333"
                        text "-" align .5,.5
                        action Function(m.remove, radial_apple)
                    button:
                        xysize 40,40 background "#333"
                        text "+" align .5,.5
                        action Function(m.add, radial_apple)
                    text "apple"
                hbox:
                    spacing 8
                    button:
                        xysize 40,40 background "#333"
                        text "-" align .5,.5
                        action Function(m.remove, radial_beer)
                    button:
                        xysize 40,40 background "#333"
                        text "+" align .5,.5
                        action Function(m.add, radial_beer)
                    text "beer"
                hbox:
                    spacing 8
                    button:
                        xysize 40,40 background "#333"
                        text "-" align .5,.5
                        action Function(m.remove, radial_burger)
                    button:
                        xysize 40,40 background "#333"
                        text "+" align .5,.5
                        action Function(m.add, radial_burger)
                    text "burger"
                hbox:
                    spacing 8
                    button:
                        xysize 40,40 background "#333"
                        text "-" align .5,.5
                        action Function(m.remove, radial_oil)
                    button:
                        xysize 40,40 background "#333"
                        text "+" align .5,.5
                        action Function(m.add, radial_oil)
                    text "oil"
                hbox:
                    spacing 8
                    button:
                        xysize 40,40 background "#333"
                        text "-" align .5,.5
                        action Function(m.remove, radial_strawberry)
                    button:
                        xysize 40,40 background "#333"
                        text "+" align .5,.5
                        action Function(m.add, radial_strawberry)
                    text "strawberry"


transform radial_menu_trans(x, y, a):
    ease .2 xoffset x yoffset y alpha a

init python:
    config.overlay_screens.append("radial_menu_screen")

